//+------------------------------------------------------------------+
//|                                         SRPercentRankSmoothed.mq4|
//|                            Copyright © @2023 StrategyQuant s.r.o.|
//|                                     http://www.strategyquant.com |
//+------------------------------------------------------------------+
#property  copyright "Copyright © Clonex @2023 StrategyQuant s.r.o."
#property  link      "https://strategyquant.com/?irgwc=1"

//---- indicator settings
#property  indicator_separate_window;
#property  indicator_buffers 2
#property  indicator_color1  Red
#property  indicator_width1  1
#property  indicator_color2  Blue
#property  indicator_width2  1
//----

extern int Lenght=120;
extern int SmootPer=12;
extern int ATRPeriod=12;
extern double Multiplication  =1;

//---- buffers
double IndiBuffer[];
double SmoothIndiBuffer[];



//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(2);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexDrawBegin(0,Lenght);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexDrawBegin(1,SmootPer);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+2);
   SetIndexBuffer(0,IndiBuffer);
   SetIndexBuffer(1,SmoothIndiBuffer);
   IndicatorShortName("SRPercentRankSmoothed("+Lenght+","+SmootPer+","+ATRPeriod+","+Multiplication+")");

   return(0);
  }

//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int i, limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars>0)
      counted_bars--;
   limit=Bars-counted_bars;

   for(i=limit; i>=0; i--)
     {
      int count =0;
       
      for(int a = 1; a<= Lenght; a++){

            double atrValue = iATR(NULL,0,ATRPeriod,i);
            if(Close[i]> (Low[i+a]-atrValue*Multiplication) && Close[i]< High[i+a]+atrValue*Multiplication)
              {
               count++;
              }
   

       }
        
         double percrank = (double)count/Lenght*100;
         IndiBuffer[i] =percrank;
         
         SmoothIndiBuffer[i] =iMAOnArray(IndiBuffer,0,SmootPer,0,MODE_SMA,i);
        
         
     }
    
   return(0);
  }

//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
